﻿using Syncfusion.XForms.DataForm;
using Syncfusion.XForms.DataForm.Editors;
using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace DataForm_Editor
{
    public class DataFomBehavior : Behavior<ContentPage>
    {
        SfDataForm dataForm = null;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            dataForm = bindable.FindByName<SfDataForm>("dataForm");
            dataForm.DataObject = new AddressInfo();
            dataForm.LabelPosition = LabelPosition.Top;
            dataForm.RegisterEditor("Entry", new CustomEntryEditor(dataForm));
            dataForm.RegisterEditor("FirstName", "Entry");
        }
    }
    
    public class CustomEntryEditor : DataFormTextEditor
    {
        public CustomEntryEditor(SfDataForm dataForm):base(dataForm)
        {

        }

        protected override Entry OnCreateEditorView(DataFormItem dataFormItem)
        {
            return new Entry();
        }
        protected override void OnInitializeView(DataFormItem dataFormItem, Entry view)
        {
            base.OnInitializeView(dataFormItem, view);
            view.MaxLength = 5;
        }
    }
    public class AddressInfo
    {
        [Display(Name ="First Name")]
        public string FirstName { get; set; }
        [Display(Name = "Last Name")]
        public string LastName { get; set; }
        
        public string Email { get; set; }
        public string Address { get; set; }
    }
}
